searchNodes=[{"ref":"ExOauth2Provider.html","title":"ExOauth2Provider","type":"module","doc":"A module that provides OAuth 2 capabilities for Elixir applications. Configuration config :my_app, ExOauth2Provider, repo: App.Repo, resource_owner: App.Users.User, application_owner: App.Users.User, default_scopes: ~w(public), optional_scopes: ~w(write update), native_redirect_uri: &quot;urn:ietf:wg:oauth:2.0:oob&quot;, authorization_code_expires_in: 600, access_token_expires_in: 7200, use_refresh_token: false, revoke_refresh_token_on_use: false, force_ssl_in_redirect_uri: true, grant_flows: ~w(authorization_code client_credentials), password_auth: nil, access_token_response_body_handler: nil If revoke_refresh_token_on_use is set to true, refresh tokens will be revoked after a related access token is used. If revoke_refresh_token_on_use is not set to true, previous tokens are revoked as soon as a new access token is created. If use_refresh_token is set to true, the refresh_token grant flow is automatically enabled. If password_auth is set to a {module, method} tuple, the password grant flow is automatically enabled. If access_token_expires_in is set to nil, access tokens will never expire."},{"ref":"ExOauth2Provider.html#authenticate_token/2","title":"ExOauth2Provider.authenticate_token/2","type":"function","doc":"Authenticate an access token. Example ExOauth2Provider.authenticate_token(&quot;Jf5rM8hQBc&quot;) Response {:ok, access_token} {:error, reason}"},{"ref":"ExOauth2Provider.AccessGrants.html","title":"ExOauth2Provider.AccessGrants","type":"module","doc":"The boundary for the OauthAccessGrants system."},{"ref":"ExOauth2Provider.AccessGrants.html#create_grant/4","title":"ExOauth2Provider.AccessGrants.create_grant/4","type":"function","doc":"Creates an access grant. Examples iex&gt; create_grant(resource_owner, application, attrs) {:ok, %OauthAccessGrant{}} iex&gt; create_grant(resource_owner, application, attrs) {:error, %Ecto.Changeset{}}"},{"ref":"ExOauth2Provider.AccessGrants.html#get_active_grant_for/3","title":"ExOauth2Provider.AccessGrants.get_active_grant_for/3","type":"function","doc":"Gets a single access grant registered with an application. Examples iex&gt; get_active_grant_for(application, &quot;jE9dk&quot;,) %OauthAccessGrant{} iex&gt; get_active_grant_for(application, &quot;jE9dk&quot;) ** nil"},{"ref":"ExOauth2Provider.AccessGrants.html#revoke/2","title":"ExOauth2Provider.AccessGrants.revoke/2","type":"function","doc":"See ExOauth2Provider.Mixin.Revocable.revoke/2."},{"ref":"ExOauth2Provider.AccessGrants.html#revoke!/2","title":"ExOauth2Provider.AccessGrants.revoke!/2","type":"function","doc":"See ExOauth2Provider.Mixin.Revocable.revoke!/2."},{"ref":"ExOauth2Provider.AccessGrants.AccessGrant.html","title":"ExOauth2Provider.AccessGrants.AccessGrant","type":"module","doc":"Handles the Ecto schema for access grant. Usage Configure lib/my_project/oauth_access_grants/oauth_access_grant.ex the following way: defmodule MyApp.OauthAccessGrants.OauthAccessGrant do use Ecto.Schema use ExOauth2Provider.AccessGrants.AccessGrant schema &quot;oauth_access_grants&quot; do access_grant_fields() timestamps() end end"},{"ref":"ExOauth2Provider.AccessGrants.AccessGrant.html#access_grant_fields/0","title":"ExOauth2Provider.AccessGrants.AccessGrant.access_grant_fields/0","type":"macro","doc":""},{"ref":"ExOauth2Provider.AccessGrants.AccessGrant.html#changeset/3","title":"ExOauth2Provider.AccessGrants.AccessGrant.changeset/3","type":"function","doc":""},{"ref":"ExOauth2Provider.AccessGrants.AccessGrant.html#put_token/1","title":"ExOauth2Provider.AccessGrants.AccessGrant.put_token/1","type":"function","doc":""},{"ref":"ExOauth2Provider.AccessGrants.AccessGrant.html#t:t/0","title":"ExOauth2Provider.AccessGrants.AccessGrant.t/0","type":"type","doc":""},{"ref":"ExOauth2Provider.AccessTokens.html","title":"ExOauth2Provider.AccessTokens","type":"module","doc":"Ecto schema for oauth access tokens"},{"ref":"ExOauth2Provider.AccessTokens.html#create_application_token/3","title":"ExOauth2Provider.AccessTokens.create_application_token/3","type":"function","doc":"Creates an application access token. Examples iex&gt; create_application_token(application, %{scopes: &quot;read write&quot;}) {:ok, %OauthAccessToken{}}"},{"ref":"ExOauth2Provider.AccessTokens.html#create_token/3","title":"ExOauth2Provider.AccessTokens.create_token/3","type":"function","doc":"Creates an access token. Examples iex&gt; create_token(resource_owner, %{application: application, scopes: &quot;read write&quot;}) {:ok, %OauthAccessToken{}} iex&gt; create_token(resource_owner, %{scopes: &quot;read write&quot;}) {:ok, %OauthAccessToken{}} iex&gt; create_token(resource_owner, %{expires_in: &quot;invalid&quot;}) {:error, %Ecto.Changeset{}}"},{"ref":"ExOauth2Provider.AccessTokens.html#get_application_token_for/3","title":"ExOauth2Provider.AccessTokens.get_application_token_for/3","type":"function","doc":"Gets the most recent, acccessible, matching access token for an application. Examples iex&gt; get_application_token_for(application, &quot;read write&quot;) %OauthAccessToken{} iex&gt; get_application_token_for(application, &quot;read invalid&quot;) nil"},{"ref":"ExOauth2Provider.AccessTokens.html#get_authorized_tokens_for/2","title":"ExOauth2Provider.AccessTokens.get_authorized_tokens_for/2","type":"function","doc":"Gets all authorized access tokens for resource owner. Examples iex&gt; get_authorized_tokens_for(resource_owner) [%OauthAccessToken{}, ...]"},{"ref":"ExOauth2Provider.AccessTokens.html#get_by_previous_refresh_token_for/2","title":"ExOauth2Provider.AccessTokens.get_by_previous_refresh_token_for/2","type":"function","doc":"Gets an old access token by previous refresh token. Examples iex&gt; get_by_previous_refresh_token_for(new_access_token, config) %OauthAccessToken{} iex&gt; get_by_previous_refresh_token_for(new_access_token, config) nil"},{"ref":"ExOauth2Provider.AccessTokens.html#get_by_refresh_token/2","title":"ExOauth2Provider.AccessTokens.get_by_refresh_token/2","type":"function","doc":"Gets an access token by the refresh token. Examples iex&gt; get_by_refresh_token(&quot;c341a5c7b331ef076eb4954668d54f590e0009e06b81b100191aa22c93044f3d&quot;) %OauthAccessToken{} iex&gt; get_by_refresh_token(&quot;75d72f326a69444a9287ea264617058dbbfe754d7071b8eef8294cbf4e7e0fdc&quot;) nil"},{"ref":"ExOauth2Provider.AccessTokens.html#get_by_refresh_token_for/3","title":"ExOauth2Provider.AccessTokens.get_by_refresh_token_for/3","type":"function","doc":"Gets an access token by the refresh token belonging to an application. Examples iex&gt; get_by_refresh_token_for(application, &quot;c341a5c7b331ef076eb4954668d54f590e0009e06b81b100191aa22c93044f3d&quot;) %OauthAccessToken{} iex&gt; get_by_refresh_token_for(application, &quot;75d72f326a69444a9287ea264617058dbbfe754d7071b8eef8294cbf4e7e0fdc&quot;) nil"},{"ref":"ExOauth2Provider.AccessTokens.html#get_by_token/2","title":"ExOauth2Provider.AccessTokens.get_by_token/2","type":"function","doc":"Gets a single access token. Examples iex&gt; get_by_token(&quot;c341a5c7b331ef076eb4954668d54f590e0009e06b81b100191aa22c93044f3d&quot;) %OauthAccessToken{} iex&gt; get_by_token(&quot;75d72f326a69444a9287ea264617058dbbfe754d7071b8eef8294cbf4e7e0fdc&quot;) nil"},{"ref":"ExOauth2Provider.AccessTokens.html#get_token_for/4","title":"ExOauth2Provider.AccessTokens.get_token_for/4","type":"function","doc":"Gets the most recent, acccessible, matching access token for a resource owner. Examples iex&gt; get_token_for(resource_owner, application, &quot;read write&quot;) %OauthAccessToken{} iex&gt; get_token_for(resource_owner, application, &quot;read invalid&quot;) nil"},{"ref":"ExOauth2Provider.AccessTokens.html#is_accessible?/1","title":"ExOauth2Provider.AccessTokens.is_accessible?/1","type":"function","doc":"Checks if an access token can be accessed. Examples iex&gt; is_accessible?(token) true iex&gt; is_accessible?(inaccessible_token) false"},{"ref":"ExOauth2Provider.AccessTokens.html#is_expired?/1","title":"ExOauth2Provider.AccessTokens.is_expired?/1","type":"function","doc":"See ExOauth2Provider.Mixin.Expirable.is_expired?/1."},{"ref":"ExOauth2Provider.AccessTokens.html#is_revoked?/1","title":"ExOauth2Provider.AccessTokens.is_revoked?/1","type":"function","doc":"See ExOauth2Provider.Mixin.Revocable.is_revoked?/1."},{"ref":"ExOauth2Provider.AccessTokens.html#revoke/2","title":"ExOauth2Provider.AccessTokens.revoke/2","type":"function","doc":"See ExOauth2Provider.Mixin.Revocable.revoke/2."},{"ref":"ExOauth2Provider.AccessTokens.html#revoke!/2","title":"ExOauth2Provider.AccessTokens.revoke!/2","type":"function","doc":"See ExOauth2Provider.Mixin.Revocable.revoke!/2."},{"ref":"ExOauth2Provider.AccessTokens.html#revoke_previous_refresh_token/2","title":"ExOauth2Provider.AccessTokens.revoke_previous_refresh_token/2","type":"function","doc":"Revokes token with refresh_token equal to previous_refresh_token and clears :previous_refresh_token attribute. Examples iex&gt; revoke_previous_refresh_token(data) {:ok, %OauthAccessToken{}} iex&gt; revoke_previous_refresh_token(invalid_data) {:error, %Ecto.Changeset{}}"},{"ref":"ExOauth2Provider.AccessTokens.AccessToken.html","title":"ExOauth2Provider.AccessTokens.AccessToken","type":"module","doc":"Handles the Ecto schema for access token. Usage Configure lib/my_project/oauth_access_tokens/oauth_access_token.ex the following way: defmodule MyApp.OauthAccessTokens.OauthAccessToken do use Ecto.Schema use ExOauth2Provider.AccessTokens.AccessToken schema &quot;oauth_access_tokens&quot; do access_token_fields() timestamps() end end"},{"ref":"ExOauth2Provider.AccessTokens.AccessToken.html#access_token_fields/0","title":"ExOauth2Provider.AccessTokens.AccessToken.access_token_fields/0","type":"macro","doc":""},{"ref":"ExOauth2Provider.AccessTokens.AccessToken.html#changeset/3","title":"ExOauth2Provider.AccessTokens.AccessToken.changeset/3","type":"function","doc":""},{"ref":"ExOauth2Provider.AccessTokens.AccessToken.html#t:t/0","title":"ExOauth2Provider.AccessTokens.AccessToken.t/0","type":"type","doc":""},{"ref":"ExOauth2Provider.Applications.html","title":"ExOauth2Provider.Applications","type":"module","doc":"The boundary for the applications system."},{"ref":"ExOauth2Provider.Applications.html#change_application/3","title":"ExOauth2Provider.Applications.change_application/3","type":"function","doc":"Create application changeset. Examples iex&gt; change_application(application) {:ok, %OauthApplication{}}"},{"ref":"ExOauth2Provider.Applications.html#create_application/3","title":"ExOauth2Provider.Applications.create_application/3","type":"function","doc":"Creates an application. Examples iex&gt; create_application(user, %{name: &quot;App&quot;, redirect_uri: &quot;http://example.com&quot;}) {:ok, %OauthApplication{}} iex&gt; create_application(user, %{name: &quot;&quot;}) {:error, %Ecto.Changeset{}}"},{"ref":"ExOauth2Provider.Applications.html#delete_application/2","title":"ExOauth2Provider.Applications.delete_application/2","type":"function","doc":"Deletes an application. Examples iex&gt; delete_application(application) {:ok, %OauthApplication{}} iex&gt; delete_application(application) {:error, %Ecto.Changeset{}}"},{"ref":"ExOauth2Provider.Applications.html#get_application/2","title":"ExOauth2Provider.Applications.get_application/2","type":"function","doc":"Gets a single application by uid. Examples iex&gt; get_application(&quot;c341a5c7b331ef076eb4954668d54f590e0009e06b81b100191aa22c93044f3d&quot;) %OauthApplication{} iex&gt; get_application(&quot;75d72f326a69444a9287ea264617058dbbfe754d7071b8eef8294cbf4e7e0fdc&quot;) nil"},{"ref":"ExOauth2Provider.Applications.html#get_application!/2","title":"ExOauth2Provider.Applications.get_application!/2","type":"function","doc":"Gets a single application by uid. Raises Ecto.NoResultsError if the Application does not exist. Examples iex&gt; get_application!(&quot;c341a5c7b331ef076eb4954668d54f590e0009e06b81b100191aa22c93044f3d&quot;) %OauthApplication{} iex&gt; get_application!(&quot;75d72f326a69444a9287ea264617058dbbfe754d7071b8eef8294cbf4e7e0fdc&quot;) ** (Ecto.NoResultsError)"},{"ref":"ExOauth2Provider.Applications.html#get_application_for!/3","title":"ExOauth2Provider.Applications.get_application_for!/3","type":"function","doc":"Gets a single application for a resource owner. Raises Ecto.NoResultsError if the OauthApplication does not exist for resource owner. Examples iex&gt; get_application_for!(owner, &quot;c341a5c7b331ef076eb4954668d54f590e0009e06b81b100191aa22c93044f3d&quot;) %OauthApplication{} iex&gt; get_application_for!(owner, &quot;75d72f326a69444a9287ea264617058dbbfe754d7071b8eef8294cbf4e7e0fdc&quot;) ** (Ecto.NoResultsError)"},{"ref":"ExOauth2Provider.Applications.html#get_applications_for/2","title":"ExOauth2Provider.Applications.get_applications_for/2","type":"function","doc":"Returns all applications for a owner. Examples iex&gt; get_applications_for(resource_owner) [%OauthApplication{}, ...]"},{"ref":"ExOauth2Provider.Applications.html#get_authorized_applications_for/2","title":"ExOauth2Provider.Applications.get_authorized_applications_for/2","type":"function","doc":"Gets all authorized applications for a resource owner. Examples iex&gt; get_authorized_applications_for(owner) [%OauthApplication{},...]"},{"ref":"ExOauth2Provider.Applications.html#load_application/3","title":"ExOauth2Provider.Applications.load_application/3","type":"function","doc":"Gets a single application by uid and secret. Examples iex&gt; load_application(&quot;c341a5c7b331ef076eb4954668d54f590e0009e06b81b100191aa22c93044f3d&quot;, &quot;SECRET&quot;) %OauthApplication{} iex&gt; load_application(&quot;75d72f326a69444a9287ea264617058dbbfe754d7071b8eef8294cbf4e7e0fdc&quot;, &quot;SECRET&quot;) nil"},{"ref":"ExOauth2Provider.Applications.html#revoke_all_access_tokens_for/3","title":"ExOauth2Provider.Applications.revoke_all_access_tokens_for/3","type":"function","doc":"Revokes all access tokens for an application and resource owner. Examples iex&gt; revoke_all_access_tokens_for(application, resource_owner) {:ok, [%OauthAccessToken{}]}"},{"ref":"ExOauth2Provider.Applications.html#update_application/3","title":"ExOauth2Provider.Applications.update_application/3","type":"function","doc":"Updates an application. Examples iex&gt; update_application(application, %{name: &quot;Updated App&quot;}) {:ok, %OauthApplication{}} iex&gt; update_application(application, %{name: &quot;&quot;}) {:error, %Ecto.Changeset{}}"},{"ref":"ExOauth2Provider.Applications.Application.html","title":"ExOauth2Provider.Applications.Application","type":"module","doc":"Handles the Ecto schema for application. Usage Configure lib/my_project/oauth_applications/oauth_application.ex the following way: defmodule MyApp.OauthApplications.OauthApplication do use Ecto.Schema use ExOauth2Provider.Applications.Application schema &quot;oauth_applications&quot; do application_fields() timestamps() end end"},{"ref":"ExOauth2Provider.Applications.Application.html#application_fields/0","title":"ExOauth2Provider.Applications.Application.application_fields/0","type":"macro","doc":""},{"ref":"ExOauth2Provider.Applications.Application.html#changeset/3","title":"ExOauth2Provider.Applications.Application.changeset/3","type":"function","doc":""},{"ref":"ExOauth2Provider.Applications.Application.html#t:t/0","title":"ExOauth2Provider.Applications.Application.t/0","type":"type","doc":""},{"ref":"ExOauth2Provider.Authorization.html","title":"ExOauth2Provider.Authorization","type":"module","doc":"Handler for dealing with generating access grants."},{"ref":"ExOauth2Provider.Authorization.html#authorize/3","title":"ExOauth2Provider.Authorization.authorize/3","type":"function","doc":"Check ExOauth2Provider.Authorization.Code for usage."},{"ref":"ExOauth2Provider.Authorization.html#deny/3","title":"ExOauth2Provider.Authorization.deny/3","type":"function","doc":"Check ExOauth2Provider.Authorization.Code for usage."},{"ref":"ExOauth2Provider.Authorization.html#preauthorize/3","title":"ExOauth2Provider.Authorization.preauthorize/3","type":"function","doc":"Check ExOauth2Provider.Authorization.Code for usage."},{"ref":"ExOauth2Provider.Authorization.Code.html","title":"ExOauth2Provider.Authorization.Code","type":"module","doc":"Methods for authorization code flow. The flow consists of three method calls: preauthorize(resource_owner, request) This validates the request. If a resource owner already have been authenticated previously it&#39;ll respond with a redirect tuple. authorize(resource_owner, request) This confirms a resource owner authorization, and will generate an access token. deny(resource_owner, request) This rejects a resource owner authorization. In a controller it could look like this: alias ExOauth2Provider.Authorization def new(conn, params) do case Authorization.preauthorize(current_resource_owner(conn), params) do {:ok, client, scopes} -&gt; render(conn, &quot;new.html&quot;, params: params, client: client, scopes: scopes) {:native_redirect, %{code: code}} -&gt; redirect(conn, to: oauth_authorization_path(conn, :show, code)) {:redirect, redirect_uri} -&gt; redirect(conn, external: redirect_uri) {:error, error, status} -&gt; conn |&gt; put_status(status) |&gt; render(&quot;error.html&quot;, error: error) end end def create(conn, params) do conn |&gt; current_resource_owner |&gt; Authorization.authorize(params) |&gt; redirect_or_render(conn) end def delete(conn, params) do conn |&gt; current_resource_owner |&gt; Authorization.deny(params) |&gt; redirect_or_render(conn) end"},{"ref":"ExOauth2Provider.Authorization.Code.html#authorize/3","title":"ExOauth2Provider.Authorization.Code.authorize/3","type":"function","doc":"Authorizes an authorization code flow request. This is used when a resource owner has authorized access. If successful, this will generate an access token grant. Example resource_owner |&gt; ExOauth2Provider.Authorization.authorize(%{ &quot;client_id&quot; =&gt; &quot;Jf5rM8hQBc&quot;, &quot;response_type&quot; =&gt; &quot;code&quot;, &quot;scope&quot; =&gt; &quot;read write&quot;, # Optional &quot;state&quot; =&gt; &quot;46012&quot;, # Optional &quot;redirect_uri&quot; =&gt; &quot;https://example.com/&quot; # Optional }) Response {:ok, code} # A grant was generated {:error, %{error: error, error_description: _}, http_status} # Error occurred {:redirect, redirect_uri} # Redirect {:native_redirect, %{code: code}} # Redirect to :show page"},{"ref":"ExOauth2Provider.Authorization.Code.html#deny/3","title":"ExOauth2Provider.Authorization.Code.deny/3","type":"function","doc":"Rejects an authorization code flow request. This is used when a resource owner has rejected access. Example resource_owner |&gt; ExOauth2Provider.Authorization.deny(%{ &quot;client_id&quot; =&gt; &quot;Jf5rM8hQBc&quot;, &quot;response_type&quot; =&gt; &quot;code&quot; }) Response type {:error, %{error: error, error_description: _}, http_status} # Error occurred {:redirect, redirect_uri} # Redirect"},{"ref":"ExOauth2Provider.Authorization.Code.html#preauthorize/3","title":"ExOauth2Provider.Authorization.Code.preauthorize/3","type":"function","doc":"Validates an authorization code flow request. Will check if there&#39;s already an existing access token with same scope and client for the resource owner. Example resource_owner |&gt; ExOauth2Provider.Authorization.preauthorize(%{ &quot;client_id&quot; =&gt; &quot;Jf5rM8hQBc&quot;, &quot;response_type&quot; =&gt; &quot;code&quot; }) Response {:ok, client, scopes} # Show request page with client and scopes {:error, %{error: error, error_description: _}, http_status} # Show error page with error and http status {:redirect, redirect_uri} # Redirect {:native_redirect, %{code: code}} # Redirect to :show page"},{"ref":"ExOauth2Provider.Plug.html","title":"ExOauth2Provider.Plug","type":"module","doc":"ExOauth2Provider.Plug contains functions that assist with interacting with ExOauth2Provider via Plugs. ExOauth2Provider.Plug is not itself a plug. Use the helpers to look up current_access_token and current_resource_owner. Example ExOauth2Provider.Plug.current_access_token(conn) ExOauth2Provider.Plug.current_resource_owner(conn)"},{"ref":"ExOauth2Provider.Plug.html#authenticated?/2","title":"ExOauth2Provider.Plug.authenticated?/2","type":"function","doc":"Check if a request is authenticated"},{"ref":"ExOauth2Provider.Plug.html#current_access_token/2","title":"ExOauth2Provider.Plug.current_access_token/2","type":"function","doc":"Fetch the currently verified token from the request. Optionally located at a key"},{"ref":"ExOauth2Provider.Plug.html#current_resource_owner/2","title":"ExOauth2Provider.Plug.current_resource_owner/2","type":"function","doc":"Fetch the currently authenticated resource if loaded, optionally located at a key"},{"ref":"ExOauth2Provider.Plug.EnsureAuthenticated.html","title":"ExOauth2Provider.Plug.EnsureAuthenticated","type":"module","doc":"This plug ensures that the request has been authenticated with an access token. If one is not found, the unauthenticated/2 function is invoked with the Plug.Conn.t object and its params. Example # Will call the unauthenticated/2 function on your handler plug ExOauth2Provider.Plug.EnsureAuthenticated, handler: SomeModule # look in the :secret location. You can also do simple claim checks: plug ExOauth2Provider.Plug.EnsureAuthenticated, handler: SomeModule, key: :secret plug ExOauth2Provider.Plug.EnsureAuthenticated, handler: SomeModule, typ: &quot;access&quot; If the handler option is not passed, ExOauth2Provider.Plug.ErrorHandler will provide the default behavior."},{"ref":"ExOauth2Provider.Plug.EnsureScopes.html","title":"ExOauth2Provider.Plug.EnsureScopes","type":"module","doc":"Use this plug to ensure that there are the correct scopes on the token found on the connection. Example alias ExOauth2Provider.Plug.EnsureScopes # With custom handler plug EnsureScopes, scopes: ~w(read write), handler: SomeMod, # item:read AND item:write scopes AND :profile scope plug EnsureScopes, scopes: ~(item:read item:write profile) # iteam:read AND item: write scope OR :profile for the default set plug EnsureScopes, one_of: [~(item:read item:write), ~(profile)] # item :read AND :write for the token located in the :secret location plug EnsureScopes, key: :secret, scopes: ~(read :write) If the handler option is not passed, ExOauth2Provider.Plug.ErrorHandler will provide the default behavior."},{"ref":"ExOauth2Provider.Plug.ErrorHandler.html","title":"ExOauth2Provider.Plug.ErrorHandler","type":"behaviour","doc":"A default error handler that can be used for failed authentication"},{"ref":"ExOauth2Provider.Plug.ErrorHandler.html#c:no_resource/2","title":"ExOauth2Provider.Plug.ErrorHandler.no_resource/2","type":"callback","doc":""},{"ref":"ExOauth2Provider.Plug.ErrorHandler.html#c:unauthenticated/2","title":"ExOauth2Provider.Plug.ErrorHandler.unauthenticated/2","type":"callback","doc":""},{"ref":"ExOauth2Provider.Plug.ErrorHandler.html#c:unauthorized/2","title":"ExOauth2Provider.Plug.ErrorHandler.unauthorized/2","type":"callback","doc":""},{"ref":"ExOauth2Provider.Plug.VerifyHeader.html","title":"ExOauth2Provider.Plug.VerifyHeader","type":"module","doc":"Use this plug to authenticate a token contained in the header. You should set the value of the Authorization header to: Authorization: &lt;token&gt; Example plug ExOauth2Provider.Plug.VerifyHeader A &quot;realm&quot; can be specified when using the plug. Realms are like the name of the token and allow many tokens to be sent with a single request. plug ExOauth2Provider.Plug.VerifyHeader, realm: &quot;Bearer&quot; When a realm is not specified, the first authorization header found is used, and assumed to be a raw token example plug ExOauth2Provider.Plug.VerifyHeader # will take the first auth header # Authorization: &lt;token&gt;"},{"ref":"ExOauth2Provider.RedirectURI.html","title":"ExOauth2Provider.RedirectURI","type":"module","doc":"Functions for dealing with redirect uri."},{"ref":"ExOauth2Provider.RedirectURI.html#matches?/2","title":"ExOauth2Provider.RedirectURI.matches?/2","type":"function","doc":"Check if uri matches client uri"},{"ref":"ExOauth2Provider.RedirectURI.html#native_redirect_uri?/2","title":"ExOauth2Provider.RedirectURI.native_redirect_uri?/2","type":"function","doc":"Check if a url is native"},{"ref":"ExOauth2Provider.RedirectURI.html#uri_with_query/2","title":"ExOauth2Provider.RedirectURI.uri_with_query/2","type":"function","doc":"Adds query parameters to uri"},{"ref":"ExOauth2Provider.RedirectURI.html#valid_for_authorization?/3","title":"ExOauth2Provider.RedirectURI.valid_for_authorization?/3","type":"function","doc":"Check if a url matches a client redirect_uri"},{"ref":"ExOauth2Provider.RedirectURI.html#validate/2","title":"ExOauth2Provider.RedirectURI.validate/2","type":"function","doc":"Validates if a url can be used as a redirect_uri"},{"ref":"ExOauth2Provider.Schema.html","title":"ExOauth2Provider.Schema","type":"module","doc":"This module will permit dynamic App.Schema load."},{"ref":"ExOauth2Provider.Scopes.html","title":"ExOauth2Provider.Scopes","type":"module","doc":"Functions for dealing with scopes."},{"ref":"ExOauth2Provider.Scopes.html#all?/2","title":"ExOauth2Provider.Scopes.all?/2","type":"function","doc":"Check if required scopes exists in the scopes list"},{"ref":"ExOauth2Provider.Scopes.html#default_to_server_scopes/2","title":"ExOauth2Provider.Scopes.default_to_server_scopes/2","type":"function","doc":"Will default to server scopes if no scopes supplied"},{"ref":"ExOauth2Provider.Scopes.html#equal?/2","title":"ExOauth2Provider.Scopes.equal?/2","type":"function","doc":"Check if two lists of scopes are equal"},{"ref":"ExOauth2Provider.Scopes.html#filter_default_scopes/2","title":"ExOauth2Provider.Scopes.filter_default_scopes/2","type":"function","doc":"Filter defaults scopes from scopes list"},{"ref":"ExOauth2Provider.Scopes.html#from_access_token/1","title":"ExOauth2Provider.Scopes.from_access_token/1","type":"function","doc":"Fetch scopes from an access token"},{"ref":"ExOauth2Provider.Scopes.html#to_list/1","title":"ExOauth2Provider.Scopes.to_list/1","type":"function","doc":"Convert scopes string to list"},{"ref":"ExOauth2Provider.Scopes.html#to_string/1","title":"ExOauth2Provider.Scopes.to_string/1","type":"function","doc":"Convert scopes list to string"},{"ref":"ExOauth2Provider.Token.html","title":"ExOauth2Provider.Token","type":"module","doc":"Handler for dealing with generating access tokens."},{"ref":"ExOauth2Provider.Token.html#grant/2","title":"ExOauth2Provider.Token.grant/2","type":"function","doc":"Grants an access token based on grant_type strategy. Example ExOauth2Provider.Token.authorize(resource_owner, %{ &quot;grant_type&quot; =&gt; &quot;invalid&quot;, &quot;client_id&quot; =&gt; &quot;Jf5rM8hQBc&quot;, &quot;client_secret&quot; =&gt; &quot;secret&quot; }) Response {:error, %{error: error, error_description: description}, http_status}"},{"ref":"ExOauth2Provider.Token.html#revoke/2","title":"ExOauth2Provider.Token.revoke/2","type":"function","doc":"Revokes an access token as per http://tools.ietf.org/html/rfc7009 Example ExOauth2Provider.Token.revoke(resource_owner, %{ &quot;client_id&quot; =&gt; &quot;Jf5rM8hQBc&quot;, &quot;client_secret&quot; =&gt; &quot;secret&quot;, &quot;token&quot; =&gt; &quot;fi3S9u&quot; }) Response {:ok, %{}}"},{"ref":"ExOauth2Provider.Token.AuthorizationCode.html","title":"ExOauth2Provider.Token.AuthorizationCode","type":"module","doc":"Functions for dealing with authorization code strategy."},{"ref":"ExOauth2Provider.Token.AuthorizationCode.html#grant/2","title":"ExOauth2Provider.Token.AuthorizationCode.grant/2","type":"function","doc":"Will grant access token by client credentials. Example ExOauth2Provider.Token.grant(%{ &quot;code&quot; =&gt; &quot;1jf6a&quot;, &quot;client_id&quot; =&gt; &quot;Jf5rM8hQBc&quot;, &quot;client_secret&quot; =&gt; &quot;secret&quot;, &quot;redirect_uri&quot; =&gt; &quot;https://example.com/&quot;, &quot;grant_type&quot; =&gt; &quot;authorization_code&quot; }) Response {:ok, access_token} {:error, %{error: error, error_description: description}, http_status}"},{"ref":"ExOauth2Provider.Token.ClientCredentials.html","title":"ExOauth2Provider.Token.ClientCredentials","type":"module","doc":"Functions for dealing with client credentials strategy."},{"ref":"ExOauth2Provider.Token.ClientCredentials.html#grant/2","title":"ExOauth2Provider.Token.ClientCredentials.grant/2","type":"function","doc":"Will grant access token by client credentials. Example ExOauth2Provider.Token.grant(%{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot;, &quot;client_id&quot; =&gt; &quot;Jf5rM8hQBc&quot;, &quot;client_secret&quot; =&gt; &quot;secret&quot; }) Response {:ok, access_token} {:error, %{error: error, error_description: description}, http_status}"},{"ref":"ExOauth2Provider.Token.Password.html","title":"ExOauth2Provider.Token.Password","type":"module","doc":"Functions for dealing with refresh token strategy."},{"ref":"ExOauth2Provider.Token.Password.html#grant/2","title":"ExOauth2Provider.Token.Password.grant/2","type":"function","doc":"Will grant access token by password authentication. Example ExOauth2Provider.Token.grant(%{ &quot;grant_type&quot; =&gt; &quot;password&quot;, &quot;client_id&quot; =&gt; &quot;Jf5rM8hQBc&quot;, &quot;client_secret&quot; =&gt; &quot;secret&quot;, &quot;username&quot; =&gt; &quot;testuser@example.com&quot;, &quot;password&quot; =&gt; &quot;secret&quot; }) Response {:ok, access_token} {:error, %{error: error, error_description: description}, http_status}"},{"ref":"ExOauth2Provider.Token.RefreshToken.html","title":"ExOauth2Provider.Token.RefreshToken","type":"module","doc":"Functions for dealing with refresh token strategy."},{"ref":"ExOauth2Provider.Token.RefreshToken.html#grant/2","title":"ExOauth2Provider.Token.RefreshToken.grant/2","type":"function","doc":"Will grant access token by refresh token. Example ExOauth2Provider.Token.authorize(%{ &quot;grant_type&quot; =&gt; &quot;refresh_token&quot;, &quot;client_id&quot; =&gt; &quot;Jf5rM8hQBc&quot;, &quot;client_secret&quot; =&gt; &quot;secret&quot;, &quot;refresh_token&quot; =&gt; &quot;1jf6a&quot; }) Response {:ok, access_token} {:error, %{error: error, error_description: description}, http_status}"},{"ref":"ExOauth2Provider.Token.Revoke.html","title":"ExOauth2Provider.Token.Revoke","type":"module","doc":"Functions for dealing with revocation."},{"ref":"ExOauth2Provider.Token.Revoke.html#revoke/2","title":"ExOauth2Provider.Token.Revoke.revoke/2","type":"function","doc":"Revokes access token. The authorization server, if applicable, first authenticates the client and checks its ownership of the provided token. ExOauth2Provider does not use the token_type_hint logic described in the RFC 7009 due to the refresh token implementation that is a field in the access token schema. Example confidential client ExOauth2Provider.Token.revoke(%{ &quot;client_id&quot; =&gt; &quot;Jf5rM8hQBc&quot;, &quot;client_secret&quot; =&gt; &quot;secret&quot;, &quot;token&quot; =&gt; &quot;fi3S9u&quot; }) Response {:ok, %{}} Example public client ExOauth2Provider.Token.revoke(%{ &quot;token&quot; =&gt; &quot;fi3S9u&quot; }) Response {:ok, %{}}"},{"ref":"Mix.ExOauth2Provider.html","title":"Mix.ExOauth2Provider","type":"module","doc":"Utilities module for mix tasks."},{"ref":"Mix.ExOauth2Provider.html#no_umbrella!/1","title":"Mix.ExOauth2Provider.no_umbrella!/1","type":"function","doc":"Raises an exception if the project is an umbrella app."},{"ref":"Mix.ExOauth2Provider.html#parse_options/3","title":"Mix.ExOauth2Provider.parse_options/3","type":"function","doc":"Parses argument options into a map."},{"ref":"Mix.ExOauth2Provider.Migration.html","title":"Mix.ExOauth2Provider.Migration","type":"module","doc":"Utilities module for ecto migrations in mix tasks."},{"ref":"Mix.ExOauth2Provider.Migration.html#create_migration_file/3","title":"Mix.ExOauth2Provider.Migration.create_migration_file/3","type":"function","doc":"Creates a migration file for a repo."},{"ref":"Mix.ExOauth2Provider.Migration.html#gen/3","title":"Mix.ExOauth2Provider.Migration.gen/3","type":"function","doc":""},{"ref":"Mix.Tasks.ExOauth2Provider.html","title":"Mix.Tasks.ExOauth2Provider","type":"task","doc":"Prints ExOauth2Provider tasks and their information. mix ex_oauth2_provider"},{"ref":"Mix.Tasks.ExOauth2Provider.Gen.Migration.html","title":"Mix.Tasks.ExOauth2Provider.Gen.Migration","type":"task","doc":"Generates migration file. mix ex_oauth2_provider.gen.migrations -r MyApp.Repo mix ex_oauth2_provider.gen.migrations -r MyApp.Repo --namespace oauth2 This generator will add the oauth2 migration file in priv/repo/migrations. The repository must be set under :ecto_repos in the current app configuration or given via the -r option. By default, the migration will be generated to the &quot;priv/YOUR_REPO/migrations&quot; directory of the current application but it can be configured to be any subdirectory of priv by specifying the :priv key under the repository configuration. Arguments -r, --repo - the repo module --binary-id - use binary id for primary keys --namespace - namespace to prepend table and schema module name"},{"ref":"Mix.Tasks.ExOauth2Provider.Gen.Schemas.html","title":"Mix.Tasks.ExOauth2Provider.Gen.Schemas","type":"task","doc":"Generates schema files. mix ex_oauth2_provider.gen.schemas mix ex_oauth2_provider.gen.schemas --binary-id --namespace oauth2 Arguments --binary-id - use binary id for primary keys --namespace - namespace to prepend table and schema module name --context-app - context app to use for path and module names"},{"ref":"Mix.Tasks.ExOauth2Provider.Install.html","title":"Mix.Tasks.ExOauth2Provider.Install","type":"task","doc":"Generates migrations, schema module files, and updates config. mix ex_oauth2_provider.install mix ex_oauth2_provider.install --no-schemas Arguments --context-app - context app to use for path and module names --no-migration - don&#39;t create migration file --no-schemas - don&#39;t create schema module files"},{"ref":"readme.html","title":"ExOauth2Provider","type":"extras","doc":"ExOauth2Provider The no-brainer library to use for adding OAuth 2.0 provider capabilities to your Elixir app. You can use phoenix_oauth2_provider for easy integration with your Phoenix app."},{"ref":"readme.html#installation","title":"ExOauth2Provider - Installation","type":"extras","doc":"Add ExOauth2Provider to your list of dependencies in mix.exs: def deps do [ # ... {:ex_oauth2_provider, &quot;~&gt; 0.5.0&quot;} # ... ] end Run mix deps.get to install it."},{"ref":"readme.html#getting-started","title":"ExOauth2Provider - Getting started","type":"extras","doc":"Generate the migrations and schema modules: mix ex_oauth2_provider.install Add the following to config/config.ex: config :my_app, ExOauth2Provider, repo: MyApp.Repo, resource_owner: MyApp.Users.User If you don&#39;t have any user setup, you shuld consider setting up Pow first."},{"ref":"readme.html#authorize-code-flow","title":"ExOauth2Provider - Authorize code flow","type":"extras","doc":"Authorization request You have to ensure that a resource_owner has been authenticated on the following endpoints, and pass the struct as the first argument in the following methods. # GET /oauth/authorize?response_type=code&amp;client_id=CLIENT_ID&amp;redirect_uri=CALLBACK_URL&amp;scope=read case ExOauth2Provider.Authorization.preauthorize(resource_owner, params, config) do {:ok, client, scopes} -&gt; # render authorization page {:redirect, redirect_uri} -&gt; # redirect to external redirect_uri {:native_redirect, %{code: code}} -&gt; # redirect to local :show endpoint {:error, error, http_status} -&gt; # render error page end # POST /oauth/authorize?response_type=code&amp;client_id=CLIENT_ID&amp;redirect_uri=CALLBACK_URL&amp;scope=read ExOauth2Provider.Authorization.authorize(resource_owner, params, config) do {:redirect, redirect_uri} -&gt; # redirect to external redirect_uri {:native_redirect, %{code: code}} -&gt; # redirect to local :show endpoint {:error, error, http_status} -&gt; # render error page end # DELETE /oauth/authorize?response_type=code&amp;client_id=CLIENT_ID&amp;redirect_uri=CALLBACK_URL&amp;scope=read ExOauth2Provider.Authorization.deny(resource_owner, params, config) do {:redirect, redirect_uri} -&gt; # redirect to external redirect_uri {:error, error, http_status} -&gt; # render error page end Authorization code grant # POST /oauth/token?client_id=CLIENT_ID&amp;client_secret=CLIENT_SECRET&amp;grant_type=authorization_code&amp;code=AUTHORIZATION_CODE&amp;redirect_uri=CALLBACK_URL case ExOauth2Provider.Token.grant(params, config) do {:ok, access_token} -&gt; # JSON response {:error, error, http_status} -&gt; # JSON response end Revocation # GET /oauth/revoke?client_id=CLIENT_ID&amp;client_secret=CLIENT_SECRET&amp;token=ACCESS_TOKEN case ExOauth2Provider.Token.revoke(params, config) do {:ok, %{}} -&gt; # JSON response {:error, error, http_status} -&gt; # JSON response end Revocation will return {:ok, %{}} status even if the token is invalid. Authorization code flow in a Single Page Application ExOauth2Provider doesn&#39;t support implicit grant flow. Instead you should set up an application with no client secret, and use the Authorize code grant flow. client_secret isn&#39;t required unless it has been set for the application. Other supported token grants Client credentials # POST /oauth/token?client_id=CLIENT_ID&amp;client_secret=CLIENT_SECRET&amp;grant_type=client_credentials case ExOauth2Provider.Token.grant(params, config) do {:ok, access_token} -&gt; # JSON response {:error, error, http_status} -&gt; # JSON response end Refresh token Refresh tokens can be enabled in the configuration: config :my_app, ExOauth2Provider, repo: MyApp.Repo, resource_owner: MyApp.Users.User, use_refresh_token: true The refresh_token grant flow will then be enabled. # POST /oauth/token?client_id=CLIENT_ID&amp;client_secret=CLIENT_SECRET&amp;grant_type=refresh_token&amp;refresh_token=REFRESH_TOKEN case ExOauth2Provider.Token.grant(params, config) do {:ok, access_token} -&gt; # JSON response {:error, error, http_status} -&gt; # JSON response end Username and password You&#39;ll need to provide an authorization method that accepts username and password as arguments, and returns {:ok, resource_owner} or {:error, reason}. Here&#39;a an example: # Configuration in config/config.exs config :my_app, ExOauth2Provider, password_auth: {Auth, :authenticate} # Module example defmodule Auth do def authenticate(username, password, config) do user = Repo.get_by(User, email: username) cond do user == nil -&gt; {:error, :no_user_found} check_pw(user.password_hash, password) -&gt; {:ok, user} true -&gt; {:error, :invalid_password} end end end The password grant flow will then be enabled. # POST /oauth/token?client_id=CLIENT_ID&amp;grant_type=password&amp;username=USERNAME&amp;password=PASSWORD case ExOauth2Provider.Token.grant(params, config) do {:ok, access_token} -&gt; # JSON response {:error, error, http_status} -&gt; # JSON response end"},{"ref":"readme.html#scopes","title":"ExOauth2Provider - Scopes","type":"extras","doc":"Server wide scopes can be defined in the configuration: config :my_app, ExOauth2Provider, repo: MyApp.Repo, resource_owner: MyApp.Users.User, default_scopes: ~w(public), optional_scopes: ~w(read update)"},{"ref":"readme.html#plug-api","title":"ExOauth2Provider - Plug API","type":"extras","doc":"ExOauth2Provider.Plug.VerifyHeader Looks for a token in the Authorization Header. If one is not found, this does nothing. This will always be necessary to run to load access token and resource owner. ExOauth2Provider.Plug.EnsureAuthenticated Looks for a verified token loaded by VerifyHeader. If one is not found it will call the :unauthenticated method in the :handler module. You can use a custom :handler as part of a pipeline, or inside a Phoenix controller like so: defmodule MyAppWeb.MyController do use MyAppWeb, :controller plug ExOauth2Provider.Plug.EnsureAuthenticated, handler: MyAppWeb.MyAuthErrorHandler end The :handler module always defaults to ExOauth2Provider.Plug.ErrorHandler. ExOauth2Provider.Plug.EnsureScopes Looks for a previously verified token. If one is found, confirms that all listed scopes are present in the token. If not, the :unauthorized function is called on your :handler. defmodule MyAppWeb.MyController do use MyAppWeb, :controller plug ExOauth2Provider.Plug.EnsureScopes, handler: MyAppWeb.MyAuthErrorHandler, scopes: ~w(read write) end When scopes&#39; sets are specified through a :one_of map, the token is searched for at least one matching scopes set to allow the request. The first set that matches will allow the request. If no set matches, the :unauthorized function is called. defmodule MyAppWeb.MyController do use MyAppWeb, :controller plug ExOauth2Provider.Plug.EnsureScopes, handler: MyAppWeb.MyAuthErrorHandler, one_of: [~w(admin), ~w(read write)] end Current resource owner and access token If the Authorization Header was verified, you&#39;ll be able to retrieve the current resource owner or access token. ExOauth2Provider.Plug.current_access_token(conn, config) # access the token in the default location ExOauth2Provider.Plug.current_access_token(conn, :secret) # access the token in the secret location ExOauth2Provider.Plug.current_resource_owner(conn) # Access the loaded resource owner in the default location ExOauth2Provider.Plug.current_resource_owner(conn, :secret) # Access the loaded resource owner in the secret location Custom access token generator You can add your own access token generator, as this example shows: # config/config.exs config :my_app, ExOauth2Provider, access_token_generator: {AccessToken, :new} defmodule AccessToken def new(access_token) do with_signer(%JWT.token{ resource_owner_id: access_token.resource_owner_id, application_id: access_token.application.id, scopes: access_token.scopes, expires_in: access_token.expires_in, created_at: access_token.created_at }, hs256(&quot;my_secret&quot;)) end end Remember to change the field type for the token column in the oauth_access_tokens table to accepts tokens larger than 255 characters. Custom access token response body You can add extra values to the response body. # config/config.exs config :my_app, ExOauth2Provider, access_token_response_body_handler: {CustomResponse, :response} defmodule CustomResponse def response(response_body, access_token) do Map.merge(response_body, %{user_id: access_token.resource_owner.id}) end end Remember to change the field type for the token column in the oauth_access_tokens table to accepts tokens larger than 255 characters."},{"ref":"readme.html#using-binary-id","title":"ExOauth2Provider - Using binary id","type":"extras","doc":"Generate migration file with binary id You&#39;ll need to create the migration file and schema modules with the argument --binary-id: mix ex_oauth2_provider.install --binary-id"},{"ref":"readme.html#acknowledgement","title":"ExOauth2Provider - Acknowledgement","type":"extras","doc":"This library was made thanks to doorkeeper, guardian and authable, that gave the conceptual building blocks. Thanks to Benjamin Schultzer for helping to refactor the code."},{"ref":"readme.html#license","title":"ExOauth2Provider - LICENSE","type":"extras","doc":"(The MIT License) Copyright (c) 2017-2019 Dan Schultzer &amp; the Contributors Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &#39;Software&#39;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &#39;AS IS&#39;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE."}]